<template>
  <el-dialog
    v-model="dialogFormVisible"
    :title="title"
    width="500px"
    @close="close"
  >
    <el-form ref="form" :model="form" :rules="rules" label-width="100px">
      <el-form-item :label="$t('dataEnquiry.xm')" prop="projectIds">
        <el-select
          v-model="form.projectIds"
          size="small"
          multiple
          placeholder="请选择"
        >
          <el-option
            v-for="item in projectData"
            :key="item.id"
            :label="item.name"
            :value="item.id"
          ></el-option>
        </el-select>
      </el-form-item>
    </el-form>
    <div class="dialog-footer">
      <el-button type="primary" size="small" @click="save">确 定</el-button>
      <el-button size="small" @click="close">取 消</el-button>
    </div>
  </el-dialog>
</template>

<script>
import { assignProject, getAllProjects } from '@/api/manage';
import { getList } from '@/api/project';
import { getProjectsByUserId } from '@/api/user';
export default {
  name: 'ManageRole',
  data() {
    return {
      form: {
        userId: '',
        projectIds: [],
      },
      projectData: [],
      clearable: true,
      title: '',
      dialogFormVisible: false,
    };
  },
  created() {},
  methods: {
    async getProjectData() {
      const { data } = await getAllProjects();
      this.projectData = data;
    },
    manageProduct(row) {
      this.title = '分配项目';
      this.form.userId = row.id;
      this.dialogFormVisible = true;
      this.getProjectData();
      this.getUserProject();
    },
    async getUserProject() {
      const { data } = await getProjectsByUserId({ userId: this.form.userId });
      for (const key in data) {
        this.form.projectIds.push(data[key].id);
      }
    },
    close() {
      this.$refs['form'].resetFields();
      this.form = this.$options.data().form;
      this.dialogFormVisible = false;
      this.$emit('fetch-data');
    },
    save() {
      console.log(this.form);
      this.$refs['form'].validate(async valid => {
        if (valid) {
          const { msg } = await assignProject(this.form);
          this.$notify({
            title: msg,
            type: 'success',
          });
          this.$refs['form'].resetFields();
          this.dialogFormVisible = false;
          this.$parent.fetchData();
        } else {
          return false;
        }
      });
    },
  },
};
</script>
<style>
.select {
  width: 100%;
}
</style>
